import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import { positionCallout } from '../../utilities/positioning/positioning.js';
import { clickedOutside } from '../../utilities/clickedOutside.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var CalloutContentBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(CalloutContentBase, _BaseComponent);

  var _super = _createSuper(CalloutContentBase);

  function CalloutContentBase() {
    var _this;

    _classCallCheck(this, CalloutContentBase);

    _this = _super.apply(this, arguments);
    _this.internalKey = new Date();
    _this.positions = null;
    _this.positionAttempts = 0;
    return _this;
  }

  _createClass(CalloutContentBase, [{
    key: "created",
    value: function created() {
      window.addEventListener('click', this.onGlobalClick, true);
      window.addEventListener('scroll', this.onGlobalScroll, true);
    }
  }, {
    key: "beforeDestroy",
    value: function beforeDestroy() {
      window.removeEventListener('click', this.onGlobalClick, true);
      window.removeEventListener('scroll', this.onGlobalScroll, true);
    }
  }, {
    key: "updated",
    value: function updated() {
      this.internalKey = new Date();
    }
  }, {
    key: "mounted",
    value: function mounted() {
      this.updatePosition();
    }
  }, {
    key: "updatePosition",
    value: function updatePosition() {
      var positions = this.positions;
      var currentProps = this.$props;
      currentProps.bounds = this.bounds;
      currentProps.target = this.target;
      var newPositions = positionCallout(currentProps, this.$refs.hostElement, this.$refs.calloutElement, this.positions);

      if (!positions && newPositions || positions && newPositions && !this._arePositionsEqual(positions, newPositions) && this.positionAttempts < 5) {
        this.positionAttempts++;
        this.positions = newPositions;
      } else if (this.positionAttempts > 0) {
        this.positionAttempts = 0;
        this.$emit('positioned', this.positions);
      }
    }
  }, {
    key: "onGlobalClick",
    value: function onGlobalClick(e) {
      var outside = clickedOutside(e, this.$refs.calloutElement);
      if (outside) this.$emit('dismiss', true);
    }
  }, {
    key: "onGlobalScroll",
    value: function onGlobalScroll(e) {
      this.$emit('dismiss', true);
    }
  }, {
    key: "_arePositionsEqual",
    value: function _arePositionsEqual(positions, newPosition) {
      return this._comparePositions(positions.elementPosition, newPosition.elementPosition) && this._comparePositions(positions.beakPosition.elementPosition, newPosition.beakPosition.elementPosition);
    }
  }, {
    key: "_comparePositions",
    value: function _comparePositions(oldPositions, newPositions) {
      for (var key in newPositions) {
        // This needs to be checked here and below because there is a linting error if for in does not immediately have an if statement
        if (newPositions.hasOwnProperty(key)) {
          var oldPositionEdge = oldPositions[key];
          var newPositionEdge = newPositions[key];

          if (oldPositionEdge !== undefined && newPositionEdge !== undefined) {
            if (oldPositionEdge.toFixed(2) !== newPositionEdge.toFixed(2)) {
              return false;
            }
          } else {
            return false;
          }
        }
      }

      return true;
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          positionCss = this.positionCss,
          isBeakVisible = this.isBeakVisible;
      return h("div", {
        "ref": "hostElement",
        "class": classNames.container
      }, [h("div", {
        "ref": "calloutElement",
        "class": classNames.root,
        "style": positionCss ? positionCss.elementPosition : null
      }, [isBeakVisible && h("div", {
        "class": classNames.beak,
        "style": positionCss && positionCss.beakPosition ? positionCss.beakPosition.elementPosition : null
      }), isBeakVisible && h("div", {
        "class": classNames.beakCurtain
      }), h("div", {
        "class": classNames.calloutMain
      }, [this.$slots.default])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          calloutMaxWidth = this.calloutMaxWidth,
          backgroundColor = this.backgroundColor,
          finalHeight = this.finalHeight,
          positions = this.positions,
          styles = this.styles,
          calloutWidth = this.calloutWidth,
          beakWidth = this.beakWidth;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        overflowYHidden: !!finalHeight,
        calloutWidth: calloutWidth,
        positions: positions,
        beakWidth: beakWidth,
        backgroundColor: backgroundColor,
        calloutMaxWidth: calloutMaxWidth
      });
    }
  }, {
    key: "actualBeakWidth",
    get: function get() {
      return Math.sqrt(this.beakWidth * this.beakWidth * 2);
    }
  }, {
    key: "positionCss",
    get: function get() {
      if (!this.positions) return null;
      var positionCss = this.positions;

      for (var key in positionCss.elementPosition) {
        positionCss.elementPosition[key] = "".concat(positionCss.elementPosition[key], "px");
      }

      for (var _key in positionCss.beakPosition.elementPosition) {
        positionCss.beakPosition.elementPosition[_key] = "".concat(positionCss.beakPosition.elementPosition[_key], "px");
      }

      return positionCss;
    }
  }, {
    key: "bounds",
    get: function get() {
      return {
        top: 0 + this.minPagePadding,
        left: 0 + this.minPagePadding,
        right: window.innerWidth - this.minPagePadding,
        bottom: window.innerHeight - this.minPagePadding,
        width: window.innerWidth - this.minPagePadding * 2,
        height: window.innerHeight - this.minPagePadding * 2
      };
    }
  }]);

  return CalloutContentBase;
}(BaseComponent);

__decorate([Prop({
  type: HTMLElement,
  required: true
}), __metadata("design:type", HTMLElement)], CalloutContentBase.prototype, "target", void 0);

__decorate([Prop({
  type: Number,
  default: null
}), __metadata("design:type", Number)], CalloutContentBase.prototype, "calloutWidth", void 0);

__decorate([Prop({
  type: Number,
  default: 16
}), __metadata("design:type", Number)], CalloutContentBase.prototype, "beakWidth", void 0);

__decorate([Prop({
  type: Number,
  default: 8
}), __metadata("design:type", Number)], CalloutContentBase.prototype, "minPagePadding", void 0);

__decorate([Prop({
  type: Boolean,
  default: true
}), __metadata("design:type", Boolean)], CalloutContentBase.prototype, "isBeakVisible", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], CalloutContentBase.prototype, "coverTarget", void 0);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], CalloutContentBase.prototype, "gapSpace", void 0);

__decorate([Prop({
  type: Number,
  default: undefined
}), __metadata("design:type", Number)], CalloutContentBase.prototype, "finalHeight", void 0);

__decorate([Prop({
  type: Number,
  default: undefined
}), __metadata("design:type", Number)], CalloutContentBase.prototype, "calloutMaxWidth", void 0);

__decorate([Prop({
  type: String,
  default: undefined
}), __metadata("design:type", String)], CalloutContentBase.prototype, "backgroundColor", void 0);

CalloutContentBase = __decorate([Component], CalloutContentBase);

export { CalloutContentBase };
