import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _mergeJSXProps from '@vue/babel-helper-vue-jsx-merge-props';
import { Layer } from '../Layer/Layer.js';
import { Modal } from '../Modal/Modal.js';
import { DialogType } from './DialogContent.types.js';
import { DialogContent } from './DialogContent.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();
var DefaultModalProps = {
  isDarkOverlay: false,
  isBlocking: false,
  className: '',
  containerClassName: '',
  topOffsetFixed: false
};
var DefaultDialogContentProps = {
  type: DialogType.normal,
  className: '',
  topButtonsProps: []
};

var DialogBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(DialogBase, _BaseComponent);

  var _super = _createSuper(DialogBase);

  function DialogBase() {
    _classCallCheck(this, DialogBase);

    return _super.apply(this, arguments);
  }

  _createClass(DialogBase, [{
    key: "render",
    value: function render() {
      var _this = this,
          _this$dialogContentPr;

      var h = arguments[0];
      var classNames = this.classNames,
          mergedModalProps = this.mergedModalProps,
          hidden = this.hidden,
          responsiveMode = this.responsiveMode;

      var onDismiss = function onDismiss(ev) {
        return _this.$emit('dismiss', ev);
      };

      var dialogContentProps = _objectSpread(_objectSpread(_objectSpread({}, DefaultDialogContentProps), this.dialogContentProps), {}, {
        // draggableHeaderClassName: dialogDraggableClassName,
        titleProps: _objectSpread({
          // tslint:disable-next-line:deprecation
          id: this._getTitleTextId()
        }, (_this$dialogContentPr = this.dialogContentProps) === null || _this$dialogContentPr === void 0 ? void 0 : _this$dialogContentPr.titleProps)
      });

      return h(Modal, _mergeJSXProps([{
        "attrs": {
          "responsiveMode": responsiveMode
        }
      }, mergedModalProps, {
        "attrs": {
          "isDarkOverlay": mergedModalProps.isDarkOverlay,
          "isBlocking": mergedModalProps.isBlocking,
          "isOpen": !hidden,
          "containerClassName": classNames.main,
          "subtitleAriaId": this._getSubTextId(),
          "titleAriaId": this._getTitleTextId()
        },
        "class": classNames.root,
        "on": {
          "dismiss": onDismiss || mergedModalProps.onDismiss
        }
      }]), [h(DialogContent, _mergeJSXProps([{
        "attrs": {
          "subTextId": this._getSubTextId(),
          "title": dialogContentProps.title,
          "subText": dialogContentProps.subText,
          "showCloseButton": mergedModalProps.isBlocking,
          "topButtonsProps": dialogContentProps.topButtonsProps,
          "type": dialogContentProps.type
        },
        "on": {
          "dismiss": onDismiss || dialogContentProps.onDismiss
        },
        "class": dialogContentProps.className
      }, dialogContentProps]), [this.$slots.default])]);
    }
  }, {
    key: "_getSubTextId",
    value: function _getSubTextId() {
      return "".concat(this.uid, "-subText"); // // tslint:disable-next-line:deprecation
      // const { ariaDescribedById, modalProps, dialogContentProps, subText } = this.props
      // let id = (modalProps && modalProps.subtitleAriaId) || ariaDescribedById
      // if (!id) {
      //   id = ((dialogContentProps && dialogContentProps.subText) || subText) && this._defaultSubTextId
      // }
      // return id
    }
  }, {
    key: "_getTitleTextId",
    value: function _getTitleTextId() {
      return "".concat(this.uid, "-title"); // // tslint:disable-next-line:deprecation
      // const { ariaLabelledById, modalProps, dialogContentProps, title } = this.props
      // let id = (modalProps && modalProps.titleAriaId) || ariaLabelledById
      // if (!id) {
      //   id = ((dialogContentProps && dialogContentProps.title) || title) && this._defaultTitleTextId
      // }
      // return id
    }
  }, {
    key: "mergedLayerProps",
    get: function get() {
      var modalProps = this.modalProps,
          onLayerDidMount = this.onLayerDidMount;

      var mergedLayerProps = _objectSpread({}, modalProps ? modalProps.layerProps : {
        onLayerDidMount: onLayerDidMount
      });

      if (onLayerDidMount && !mergedLayerProps.onLayerDidMount) {
        mergedLayerProps.onLayerDidMount = onLayerDidMount;
      }

      return mergedLayerProps;
    }
  }, {
    key: "dragOptions",
    get: function get() {
      var modalProps = this.modalProps;
      var dialogDraggableClassName;
      var dragOptions; // if we are draggable, make sure we are using the correct
      // draggable classname and selectors

      if (modalProps && modalProps.dragOptions && !modalProps.dragOptions.dragHandleSelector) {
        dialogDraggableClassName = 'ms-Dialog-draggable-header';
        dragOptions = _objectSpread(_objectSpread({}, modalProps.dragOptions), {}, {
          dragHandleSelector: ".".concat(dialogDraggableClassName)
        });
      } else {
        dragOptions = modalProps && modalProps.dragOptions;
      }

      return dragOptions;
    }
  }, {
    key: "mergedModalProps",
    get: function get() {
      var className = this.className,
          modalProps = this.modalProps,
          dragOptions = this.dragOptions;
      return _objectSpread(_objectSpread(_objectSpread({
        className: className
      }, DefaultModalProps), modalProps), {}, {
        layerProps: this.mergedLayerProps,
        dragOptions: dragOptions
      });
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          mergedModalProps = this.mergedModalProps,
          hidden = this.hidden,
          minWidth = this.minWidth,
          maxWidth = this.maxWidth;
      return getClassNames(styles, {
        theme: theme,
        className: mergedModalProps.className,
        hidden: hidden,
        dialogDefaultMinWidth: minWidth,
        dialogDefaultMaxWidth: maxWidth
      });
    }
  }]);

  return DialogBase;
}(BaseComponent);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], DialogBase.prototype, "dialogContentProps", void 0);

__decorate([Prop({
  type: Boolean,
  default: true
}), __metadata("design:type", Boolean)], DialogBase.prototype, "hidden", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "modalProps", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "minWidth", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "maxWidth", void 0);

__decorate([Prop({
  type: Function,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "onLayerDidMount", void 0);

__decorate([Prop({
  type: Number,
  default: null
}), __metadata("design:type", Number)], DialogBase.prototype, "responsiveMode", void 0);

DialogBase = __decorate([Component({
  components: {
    Layer: Layer
  }
})], DialogBase);

export { DialogBase };
