import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import StatelessComponent from '../StatelessComponent.js';
import { getIconContent } from './FontIcon.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction({
  // Icon is used a lot by other components.
  // It's likely to see expected cases which pass different className to the Icon.
  // Therefore setting a larger cache size.
  cacheSize: 100
});

var Icon = /*#__PURE__*/function (_StatelessComponent) {
  _inherits(Icon, _StatelessComponent);

  var _super = _createSuper(Icon);

  function Icon() {
    _classCallCheck(this, Icon);

    return _super.apply(this, arguments);
  }

  _createClass(Icon, [{
    key: "render",
    value: function render(h, context) {
      var _context$props = context.props,
          className = _context$props.className,
          iconName = _context$props.iconName,
          theme = _context$props.theme,
          styles = _context$props.styles;
      var isPlaceholder = typeof iconName === 'string' && iconName.length === 0;
      var isImage = !!context.props.imageProps;
      var iconContent = getIconContent(iconName) || {};
      var children = iconContent.children;
      var iconClassName = iconContent.iconClassName;
      var classNames = getClassNames(styles, {
        theme: theme,
        className: className,
        iconClassName: iconClassName,
        isImage: isImage,
        isPlaceholder: isPlaceholder
      });
      var RootType = isImage ? 'span' : 'i';
      return h(RootType, _objectSpread(_objectSpread({}, context.data), {}, {
        class: classNames.root,
        attrs: {
          'aria-hidden': 'true',
          'data-icon-name': iconName
        }
      }), typeof children === 'function' ? [children(h)] : children);
    }
  }]);

  return Icon;
}(StatelessComponent);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], Icon.prototype, "iconName", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], Icon.prototype, "imageProps", void 0);

Icon = __decorate([Component], Icon);
var Icon$1 = Icon;

export default Icon$1;
