import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop } from 'vue-property-decorator';
import BaseComponent from '../BaseComponent.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _mergeJSXProps from '@vue/babel-helper-vue-jsx-merge-props';
import { DirectionalHint } from '../../common/DirectionalHint.js';
import { Callout } from '../Callout/Callout.js';
import { ktpTargetFromSequences, mergeOverflows } from '../../utilities/keytips/KeytipUtils.js';
import { getCalloutOffsetStyles, getCalloutStyles } from './Keytip.styles.js';
import { KeytipContent } from './KeytipContent.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
/**
 * A callout corresponding to another Fabric component to describe a key sequence that will activate that component
 */

var Keytip = /*#__PURE__*/function (_BaseComponent) {
  _inherits(Keytip, _BaseComponent);

  var _super = _createSuper(Keytip);

  function Keytip() {
    _classCallCheck(this, Keytip);

    return _super.apply(this, arguments);
  }

  _createClass(Keytip, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var keySequences = this.keySequences,
          offset = this.offset,
          overflowSetSequence = this.overflowSetSequence;
      var calloutProps = this.calloutProps;
      var keytipTarget; // Take into consideration the overflow sequence

      if (overflowSetSequence) {
        keytipTarget = ktpTargetFromSequences(mergeOverflows(keySequences, overflowSetSequence));
      } else {
        keytipTarget = ktpTargetFromSequences(keySequences);
      }

      if (offset) {
        // Set callout to top-left corner, will be further positioned in
        // getCalloutOffsetStyles
        calloutProps = _objectSpread(_objectSpread({}, calloutProps), {}, {
          coverTarget: true,
          directionalHint: DirectionalHint.topLeftEdge
        });
      }

      if (!calloutProps || calloutProps.directionalHint === undefined) {
        // Default callout directional hint to BottomCenter
        calloutProps = _objectSpread(_objectSpread({}, calloutProps), {}, {
          directionalHint: DirectionalHint.bottomCenter
        });
      }

      return h(Callout, _mergeJSXProps([{}, calloutProps, {
        "attrs": {
          "isBeakVisible": false,
          "doNotLayer": true,
          "minPagePadding": 0,
          "styles": offset ? getCalloutOffsetStyles(offset) : getCalloutStyles,
          "preventDismissOnScroll": true,
          "target": keytipTarget
        }
      }]), [h(KeytipContent, {
        "props": _objectSpread({}, this.$props)
      })]);
    }
  }]);

  return Keytip;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  default: undefined
}), __metadata("design:type", Array)], Keytip.prototype, "keySequences", void 0);

__decorate([Prop({
  type: Object,
  default: undefined
}), __metadata("design:type", Object)], Keytip.prototype, "offset", void 0);

__decorate([Prop({
  type: Array,
  default: undefined
}), __metadata("design:type", Array)], Keytip.prototype, "overflowSetSequence", void 0);

__decorate([Prop({
  type: Object,
  default: undefined
}), __metadata("design:type", Object)], Keytip.prototype, "calloutProps", void 0);

export { Keytip };
