import { mergeStyleSets, HighContrastSelector } from '@uifabric/styling';
import _defineProperty from '@babel/runtime/helpers/defineProperty';

var getStyles = function getStyles(props) {
  var theme = props.theme,
      disabled = props.disabled,
      visible = props.visible;
  return {
    container: [{
      backgroundColor: theme.palette.neutralDark
    }, disabled && {
      opacity: 0.5,
      selectors: _defineProperty({}, HighContrastSelector, {
        color: 'GrayText',
        opacity: 1
      })
    }, !visible && {
      visibility: 'hidden'
    }],
    root: [theme.fonts.medium, {
      textAlign: 'center',
      paddingLeft: '3px',
      paddingRight: '3px',
      backgroundColor: theme.palette.neutralDark,
      color: theme.palette.neutralLight,
      minWidth: '11px',
      lineHeight: '17px',
      height: '17px',
      display: 'inline-block'
    }, disabled && {
      color: theme.palette.neutralTertiaryAlt
    }]
  };
};
var getCalloutStyles = function getCalloutStyles(props) {
  return {
    container: [],
    root: [{
      border: 'none',
      boxShadow: 'none'
    }],
    beak: [],
    beakCurtain: [],
    calloutMain: [{
      backgroundColor: 'transparent'
    }]
  };
};
var getCalloutOffsetStyles = function getCalloutOffsetStyles(offset) {
  return function (props) {
    return mergeStyleSets(getCalloutStyles(), {
      root: [{
        marginLeft: offset.left || offset.x,
        marginTop: offset.top || offset.y
      }]
    });
  };
};

export { getCalloutOffsetStyles, getCalloutStyles, getStyles };
