import { getGlobalClassNames, HighContrastSelector, getEdgeChromiumNoHighContrastAdjustSelector } from '@uifabric/styling';
import _defineProperty from '@babel/runtime/helpers/defineProperty';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var GlobalClassNames = {
  root: 'ms-Link'
};
var getStyles = function getStyles(props) {
  var className = props.className,
      isButton = props.isButton,
      isDisabled = props.isDisabled,
      theme = props.theme;
  var semanticColors = theme.semanticColors; // Tokens

  var linkColor = semanticColors.link;
  var linkInteractedColor = semanticColors.linkHovered;
  var linkDisabledColor = semanticColors.disabledText;
  var focusBorderColor = semanticColors.focusBorder;
  var classNames = getGlobalClassNames(GlobalClassNames, theme);
  return {
    root: [classNames.root, theme.fonts.medium, {
      color: linkColor,
      outline: 'none',
      fontSize: 'inherit',
      fontWeight: 'inherit',
      textDecoration: 'none',
      selectors: _defineProperty({
        '.ms-Fabric--isFocusVisible &:focus': {
          // Can't use getFocusStyle because it doesn't support wrapping links
          // https://github.com/microsoft/fluentui/issues/4883#issuecomment-406743543
          // Using box-shadow and outline allows the focus rect to wrap links that span multiple lines
          // and helps the focus rect avoid getting clipped.
          boxShadow: "0 0 0 1px ".concat(focusBorderColor, " inset"),
          outline: "1px auto ".concat(focusBorderColor),
          selectors: _defineProperty({}, HighContrastSelector, {
            outline: '1px solid WindowText'
          })
        }
      }, HighContrastSelector, {
        // For IE high contrast mode
        borderBottom: 'none'
      })
    }, isButton && {
      background: 'none',
      backgroundColor: 'transparent',
      border: 'none',
      cursor: 'pointer',
      display: 'inline',
      margin: 0,
      overflow: 'inherit',
      padding: 0,
      textAlign: 'left',
      textOverflow: 'inherit',
      userSelect: 'text',
      borderBottom: '1px solid transparent',
      selectors: _objectSpread(_defineProperty({}, HighContrastSelector, {
        color: 'LinkText'
      }), getEdgeChromiumNoHighContrastAdjustSelector())
    }, !isButton && {
      selectors: _defineProperty({}, HighContrastSelector, {
        // This is mainly for MessageBar, which sets MsHighContrastAdjust: none by default
        MsHighContrastAdjust: 'auto'
      })
    }, isDisabled && ['is-disabled', {
      color: linkDisabledColor,
      cursor: 'default'
    }, {
      selectors: {
        '&:link, &:visited': {
          pointerEvents: 'none'
        }
      }
    }], !isDisabled && {
      selectors: {
        '&:active, &:hover, &:active:hover': {
          color: linkInteractedColor,
          textDecoration: 'underline',
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'LinkText'
          })
        },
        '&:focus': {
          color: linkColor,
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'LinkText'
          })
        }
      }
    }, classNames.root, className]
  };
};

export { getStyles };
