import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction(); // if the percentComplete is near 0, don't animate it.
// This prevents animations on reset to 0 scenarios

var ZERO_THRESHOLD = 0.01;

var ProgressIndicatorBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ProgressIndicatorBase, _BaseComponent);

  var _super = _createSuper(ProgressIndicatorBase);

  function ProgressIndicatorBase() {
    _classCallCheck(this, ProgressIndicatorBase);

    return _super.apply(this, arguments);
  }

  _createClass(ProgressIndicatorBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          label = this.label,
          progressHidden = this.progressHidden,
          progressBarStyles = this.progressBarStyles,
          description = this.description;
      return h("div", {
        "class": classNames.root
      }, [label && h("div", {
        "class": classNames.itemName
      }, [label]), !progressHidden && h("div", {
        "class": classNames.itemProgress
      }, [h("div", {
        "class": classNames.progressTrack
      }), h("div", {
        "class": classNames.progressBar,
        "style": progressBarStyles
      })]), description && h("div", {
        "class": classNames.itemDescription
      }, [description])]);
    }
  }, {
    key: "internalPercentComplete",
    get: function get() {
      return typeof this.percentComplete === 'number' ? Math.min(100, Math.max(0, this.percentComplete * 100)) : undefined;
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          internalPercentComplete = this.internalPercentComplete,
          barHeight = this.barHeight;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        barHeight: barHeight,
        indeterminate: internalPercentComplete === undefined
      });
    }
  }, {
    key: "progressBarStyles",
    get: function get() {
      var internalPercentComplete = this.internalPercentComplete;
      return {
        width: internalPercentComplete !== undefined ? internalPercentComplete + '%' : undefined,
        transition: internalPercentComplete !== undefined && internalPercentComplete < ZERO_THRESHOLD ? 'none' : undefined
      };
    }
  }]);

  return ProgressIndicatorBase;
}(BaseComponent);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ProgressIndicatorBase.prototype, "progressHidden", void 0);

__decorate([Prop({
  type: Number,
  default: undefined
}), __metadata("design:type", Number)], ProgressIndicatorBase.prototype, "percentComplete", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ProgressIndicatorBase.prototype, "label", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ProgressIndicatorBase.prototype, "description", void 0);

__decorate([Prop({
  type: Number,
  default: 2
}), __metadata("design:type", Number)], ProgressIndicatorBase.prototype, "barHeight", void 0);

ProgressIndicatorBase = __decorate([Component], ProgressIndicatorBase);

export { ProgressIndicatorBase };
