import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction, getRTL } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { ScrollbarVisibility } from './ScrollablePane.types.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ScrollablePaneBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ScrollablePaneBase, _BaseComponent);

  var _super = _createSuper(ScrollablePaneBase);

  function ScrollablePaneBase() {
    var _this;

    _classCallCheck(this, ScrollablePaneBase);

    _this = _super.apply(this, arguments);
    _this.stickyTopHeight = 0;
    _this.stickyBottomHeight = 0;
    _this.scrollbarWidth = 0;
    _this.scrollbarHeight = 0;
    _this.subscribers = new Set();
    _this.stickies = new Set();
    _this.mutationObserver = null;
    return _this;
  }

  _createClass(ScrollablePaneBase, [{
    key: "created",
    value: function created() {
      this.notifyThrottled = this._async.throttle(this.notifySubscribers, 50);
    }
  }, {
    key: "mounted",
    value: function mounted() {
      var _this2 = this;

      this.events.on(this.$refs.contentContainer, 'scroll', this._onScroll);
      this.events.on(window, 'resize', this._onWindowResize);
      var initialScrollPosition = this.initialScrollPosition;

      if (this.$refs.contentContainer && initialScrollPosition) {
        this.$refs.contentContainer.scrollTop = initialScrollPosition;
      } // Set sticky distances from top property, then sort in correct order and notify subscribers


      this.setStickiesDistanceFromTop();
      this.stickies.forEach(function (sticky) {
        _this2.sortSticky(sticky);
      });
      this.notifySubscribers();

      if ('MutationObserver' in window) {
        this.mutationObserver = new MutationObserver(function (mutation) {
          // Function to check if mutation is occuring in stickyAbove or stickyBelow
          function checkIfMutationIsSticky(mutationRecord) {
            if (this.$refs.stickyAbove !== null && this.$refs.stickyBelow !== null) {
              return this.$refs.stickyAbove.contains(mutationRecord.target) || this.$refs.stickyBelow.contains(mutationRecord.target);
            }

            return false;
          } // Compute the scrollbar height, which might have changed if the content's width changed and caused overflow


          var scrollbarHeight = _this2._getScrollbarHeight(); // If the scrollbar height changed, update state so it's postioned correctly below sticky footer


          if (scrollbarHeight !== _this2.scrollbarHeight) {
            _this2.scrollbarHeight = scrollbarHeight;
          } // Notify subscribers again to re-check whether Sticky should be Sticky'd or not


          _this2.notifySubscribers(); // If mutation occurs in sticky header or footer, then update sticky top/bottom heights


          if (mutation.some(checkIfMutationIsSticky.bind(_this2))) {
            _this2.updateStickyRefHeights();
          } else {
            // If mutation occurs in scrollable region, then find Sticky it belongs to and force update
            var stickyList = [];

            _this2.stickies.forEach(function (sticky) {
              if (sticky.$refs.root && sticky.$refs.root.contains(mutation[0].target)) {
                stickyList.push(sticky);
              }
            });

            if (stickyList.length) {
              stickyList.forEach(function (sticky) {
                sticky.$forceUpdate();
              });
            }
          }
        });

        if (this.$refs.root) {
          this.mutationObserver.observe(this.$refs.root, {
            childList: true,
            attributes: true,
            subtree: true,
            characterData: true
          });
        }
      }
    }
  }, {
    key: "setStickiesDistanceFromTop",
    value: function setStickiesDistanceFromTop() {
      var _this3 = this;

      if (this.$refs.contentContainer) {
        this.stickies.forEach(function (sticky) {
          sticky.setDistanceFromTop(_this3.$refs.contentContainer);
        });
      }
    }
  }, {
    key: "forceLayoutUpdate",
    value: function forceLayoutUpdate() {
      this._onWindowResize();
    }
  }, {
    key: "subscribe",
    value: function subscribe(handler) {
      this.subscribers.add(handler);
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe(handler) {
      this.subscribers.delete(handler);
    }
  }, {
    key: "addSticky",
    value: function addSticky(sticky) {
      this.stickies.add(sticky); // If ScrollablePane is mounted, then sort sticky in correct place

      if (this.$refs.contentContainer) {
        sticky.setDistanceFromTop(this.$refs.contentContainer);
        this.sortSticky(sticky);
      }
    }
  }, {
    key: "removeSticky",
    value: function removeSticky(sticky) {
      this.stickies.delete(sticky);

      this._removeStickyFromContainers(sticky);

      this.notifySubscribers();
    }
  }, {
    key: "sortSticky",
    value: function sortSticky(sticky, sortAgain) {
      if (this.$refs.stickyAbove && this.$refs.stickyBelow) {
        if (sortAgain) {
          this._removeStickyFromContainers(sticky);
        }

        if (sticky.canStickyTop && sticky.$refs.stickyContentTop) {
          this._addToStickyContainer(sticky, this.$refs.stickyAbove, sticky.$refs.stickyContentTop);
        }

        if (sticky.canStickyBottom && sticky.$refs.stickyContentBottom) {
          this._addToStickyContainer(sticky, this.$refs.stickyBelow, sticky.$refs.stickyContentBottom);
        }
      }
    }
  }, {
    key: "updateStickyRefHeights",
    value: function updateStickyRefHeights() {
      var _this4 = this;

      var stickyItems = this.stickies;
      var stickyTopHeight = 0;
      var stickyBottomHeight = 0;
      stickyItems.forEach(function (sticky) {
        var isStickyTop = sticky.isStickyTop,
            isStickyBottom = sticky.isStickyBottom;

        if (sticky.$refs.nonStickyContent) {
          if (isStickyTop) {
            stickyTopHeight += sticky.$refs.nonStickyContent.offsetHeight;
          }

          if (isStickyBottom) {
            stickyBottomHeight += sticky.$refs.nonStickyContent.offsetHeight;
          }

          _this4._checkStickyStatus(sticky);
        }
      });
      this.stickyTopHeight = stickyTopHeight;
      this.stickyBottomHeight = stickyBottomHeight;
    }
  }, {
    key: "notifySubscribers",
    value: function notifySubscribers() {
      var _this5 = this;

      if (this.$refs.contentContainer) {
        this.subscribers.forEach(function (handle) {
          // this.$refs.stickyBelow is passed in for calculating distance to determine Sticky status
          handle(_this5.$refs.contentContainer, _this5.$refs.stickyBelow);
        });
      }
    }
  }, {
    key: "getScrollPosition",
    value: function getScrollPosition() {
      if (this.$refs.contentContainer) {
        return this.$refs.contentContainer.scrollTop;
      }

      return 0;
    }
  }, {
    key: "syncScrollSticky",
    value: function syncScrollSticky(sticky) {
      if (sticky && this.$refs.contentContainer) {
        sticky.syncScroll(this.$refs.contentContainer);
      }
    }
  }, {
    key: "_checkStickyStatus",
    value: function _checkStickyStatus(sticky) {
      if (this.$refs.stickyAbove && this.$refs.stickyBelow && this.$refs.contentContainer && sticky.$refs.nonStickyContent) {
        // If sticky is sticky, then append content to appropriate container
        if (sticky.isStickyTop || sticky.isStickyBottom) {
          if (sticky.isStickyTop && !this.$refs.stickyAbove.contains(sticky.$refs.nonStickyContent) && sticky.$refs.stickyContentTop) {
            sticky.addSticky(sticky.$refs.stickyContentTop);
          }

          if (sticky.isStickyBottom && !this.$refs.stickyBelow.contains(sticky.$refs.nonStickyContent) && sticky.$refs.stickyContentBottom) {
            sticky.addSticky(sticky.$refs.stickyContentBottom);
          }
        } else if (!this.$refs.contentContainer.contains(sticky.$refs.nonStickyContent)) {
          // Reset sticky if it's not sticky and not in the contentContainer element
          sticky.resetSticky();
        }
      }
    }
  }, {
    key: "_addToStickyContainer",
    value: function _addToStickyContainer(sticky, stickyContainer, stickyContentToAdd) {
      var _this6 = this;

      // If there's no children, append child to list, otherwise, sort though array and append at correct position
      if (!stickyContainer.children.length) {
        stickyContainer.appendChild(stickyContentToAdd);
      } else {
        // If stickyContentToAdd isn't a child element of target container, then append
        if (!stickyContainer.contains(stickyContentToAdd)) {
          var stickyChildrenElements = [].slice.call(stickyContainer.children);
          var stickyList = []; // Get stickies.  Filter by canStickyTop/Bottom, then sort by distance from top, and then
          // filter by elements that are in the stickyContainer already.

          this.stickies.forEach(function (stickyItem) {
            if (stickyContainer === _this6.$refs.stickyAbove && sticky.canStickyTop) {
              stickyList.push(stickyItem);
            } else if (sticky.canStickyBottom) {
              stickyList.push(stickyItem);
            }
          });
          var stickyListSorted = stickyList.sort(function (a, b) {
            return (a.distanceFromTop || 0) - (b.distanceFromTop || 0);
          }).filter(function (item) {
            var stickyContent = stickyContainer === _this6.$refs.stickyAbove ? item.stickyContentTop : item.stickyContentBottom;

            if (stickyContent) {
              return stickyChildrenElements.indexOf(stickyContent) > -1;
            }
          }); // Get first element that has a distance from top that is further than our sticky that is being added

          var targetStickyToAppendBefore;

          var _iterator = _createForOfIteratorHelper(stickyListSorted),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var stickyListItem = _step.value;

              if ((stickyListItem.distanceFromTop || 0) >= (sticky.distanceFromTop || 0)) {
                targetStickyToAppendBefore = stickyListItem;
                break;
              }
            } // If target element to append before is known, then grab respective stickyContentTop/Bottom element and insert before

          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }

          var targetContainer = null;

          if (targetStickyToAppendBefore) {
            targetContainer = stickyContainer === this.$refs.stickyAbove ? targetStickyToAppendBefore.stickyContentTop : targetStickyToAppendBefore.stickyContentBottom;
          }

          stickyContainer.insertBefore(stickyContentToAdd, targetContainer);
        }
      }
    }
  }, {
    key: "_removeStickyFromContainers",
    value: function _removeStickyFromContainers(sticky) {
      if (this.$refs.stickyAbove && sticky.stickyContentTop && this.$refs.stickyAbove.contains(sticky.stickyContentTop)) {
        this.$refs.stickyAbove.removeChild(sticky.stickyContentTop);
      }

      if (this.$refs.stickyBelow && sticky.stickyContentBottom && this.$refs.stickyBelow.contains(sticky.stickyContentBottom)) {
        this.$refs.stickyBelow.removeChild(sticky.stickyContentBottom);
      }
    }
  }, {
    key: "_onWindowResize",
    value: function _onWindowResize() {
      var scrollbarWidth = this._getScrollbarWidth();

      var scrollbarHeight = this._getScrollbarHeight();

      this.scrollbarWidth = scrollbarWidth;
      this.scrollbarHeight = scrollbarHeight;
      this.notifySubscribers();
    }
  }, {
    key: "getStickyContainerStyle",
    value: function getStickyContainerStyle(height, isTop) {
      return _objectSpread(_objectSpread({
        height: height
      }, getRTL(this.theme) ? {
        right: '0',
        left: "".concat(this.scrollbarWidth || this._getScrollbarWidth() || 0, "px")
      } : {
        left: '0',
        right: "".concat(this.scrollbarWidth || this._getScrollbarWidth() || 0, "px")
      }), isTop ? {
        top: '0'
      } : {
        bottom: "".concat(this.scrollbarHeight || this._getScrollbarHeight() || 0, "px")
      });
    }
  }, {
    key: "_getScrollbarWidth",
    value: function _getScrollbarWidth() {
      var contentContainer = this.$refs.contentContainer;
      return contentContainer ? contentContainer.offsetWidth - contentContainer.clientWidth : 0;
    }
  }, {
    key: "_getScrollbarHeight",
    value: function _getScrollbarHeight() {
      var contentContainer = this.$refs.contentContainer;
      return contentContainer ? contentContainer.offsetHeight - contentContainer.clientHeight : 0;
    }
  }, {
    key: "_onScroll",
    value: function _onScroll() {
      var contentContainer = this.$refs.contentContainer;

      if (contentContainer) {
        this.stickies.forEach(function (sticky) {
          // @ts-ignore
          sticky.syncScroll(contentContainer);
        });
      }

      this.notifyThrottled();
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          stickyBottomHeight = this.stickyBottomHeight,
          stickyTopHeight = this.stickyTopHeight;
      return h("div", {
        "ref": "root",
        "class": classNames.root
      }, [h("div", {
        "ref": "stickyAbove",
        "attrs": {
          "aria-hidden": "true"
        },
        "class": classNames.stickyAbove,
        "style": this.getStickyContainerStyle(stickyTopHeight, true)
      }), h("div", {
        "ref": "contentContainer",
        "class": classNames.contentContainer,
        "attrs": {
          "data-is-scrollable": "true"
        }
      }, [this.$slots.default]), h("div", {
        "attrs": {
          "aria-hidden": "true"
        },
        "class": classNames.stickyBelow,
        "style": this.getStickyContainerStyle(stickyBottomHeight, false)
      }, [h("div", {
        "ref": "stickyBelow",
        "class": classNames.stickyBelowItems
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var className = this.className,
          theme = this.theme,
          styles = this.styles;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        scrollbarVisibility: this.scrollbarVisibility
      });
    }
  }]);

  return ScrollablePaneBase;
}(BaseComponent);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], ScrollablePaneBase.prototype, "initialScrollPosition", void 0);

__decorate([Prop({
  type: String,
  default: ScrollbarVisibility.auto
}), __metadata("design:type", String)], ScrollablePaneBase.prototype, "scrollbarVisibility", void 0);

ScrollablePaneBase = __decorate([Component({
  components: {},
  provide: function provide() {
    return {
      context: {
        scrollablePane: {
          subscribe: this.subscribe,
          unsubscribe: this.unsubscribe,
          addSticky: this.addSticky,
          removeSticky: this.removeSticky,
          updateStickyRefHeights: this.updateStickyRefHeights,
          sortSticky: this.sortSticky,
          notifySubscribers: this.notifySubscribers,
          syncScrollSticky: this.syncScrollSticky
        }
      }
    };
  }
})], ScrollablePaneBase);

export { ScrollablePaneBase };
