import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction, memoizeFunction } from '@uifabric-vue/utilities';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import StatelessComponent from '../../StatelessComponent.js';
import { ShimmerElementType, ShimmerElementsDefaultHeights } from '../Shimmer.types.js';
import { ShimmerLine } from '../ShimmerLine/ShimmerLine.js';
import { ShimmerCircle } from '../ShimmerCircle/ShimmerCircle.js';
import { ShimmerGap } from '../ShimmerGap/ShimmerGap.js';
import { h } from '@vue/composition-api';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ShimmerElementsGroupBase = /*#__PURE__*/function (_StatelessComponent) {
  _inherits(ShimmerElementsGroupBase, _StatelessComponent);

  var _super = _createSuper(ShimmerElementsGroupBase);

  function ShimmerElementsGroupBase() {
    _classCallCheck(this, ShimmerElementsGroupBase);

    return _super.apply(this, arguments);
  }

  _createClass(ShimmerElementsGroupBase, [{
    key: "render",
    value: function render(h, ctx) {
      var _ctx$props = ctx.props,
          styles = _ctx$props.styles,
          width = _ctx$props.width,
          shimmerElements = _ctx$props.shimmerElements,
          _ctx$props$rowHeight = _ctx$props.rowHeight,
          rowHeight = _ctx$props$rowHeight === void 0 ? findMaxElementHeight(shimmerElements || []) : _ctx$props$rowHeight,
          _ctx$props$flexWrap = _ctx$props.flexWrap,
          flexWrap = _ctx$props$flexWrap === void 0 ? false : _ctx$props$flexWrap,
          theme = _ctx$props.theme,
          backgroundColor = _ctx$props.backgroundColor;
      var classNames = getClassNames(styles, {
        theme: theme,
        flexWrap: flexWrap
      });
      return h("div", {
        "style": {
          width: width
        },
        "class": classNames.root
      }, [getRenderedElements(shimmerElements, backgroundColor, rowHeight)]);
    }
  }]);

  return ShimmerElementsGroupBase;
}(StatelessComponent);

__decorate([Prop({
  type: Array,
  default: undefined
}), __metadata("design:type", Array)], ShimmerElementsGroupBase.prototype, "shimmerElements", void 0);

__decorate([Prop({
  type: String,
  default: 'auto'
}), __metadata("design:type", String)], ShimmerElementsGroupBase.prototype, "width", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ShimmerElementsGroupBase.prototype, "flexWrap", void 0);

ShimmerElementsGroupBase = __decorate([Component], ShimmerElementsGroupBase);
var ShimmerElementsGroupBase$1 = ShimmerElementsGroupBase;

function getRenderedElements(shimmerElements, backgroundColor, rowHeight) {
  var renderedElements = shimmerElements ? shimmerElements.map( // false positive
  // eslint-disable-next-line array-callback-return
  function (element, index) {
    var type = element.type,
        filteredElem = _objectWithoutProperties(element, ["type"]);

    var verticalAlign = filteredElem.verticalAlign,
        height = filteredElem.height;
    var styles = getElementStyles(verticalAlign, type, height, backgroundColor, rowHeight);

    switch (element.type) {
      case ShimmerElementType.circle:
        return h(ShimmerCircle, {
          "key": index,
          "props": _objectSpread({}, _objectSpread(_objectSpread({}, filteredElem), {}, {
            styles: styles
          }))
        });

      case ShimmerElementType.gap:
        return h(ShimmerGap, {
          "key": index,
          "props": _objectSpread({}, _objectSpread(_objectSpread({}, filteredElem), {}, {
            styles: styles
          }))
        });

      case ShimmerElementType.line:
        return h(ShimmerLine, {
          "key": index,
          "props": _objectSpread({}, _objectSpread(_objectSpread({}, filteredElem), {}, {
            styles: styles
          }))
        });
    }
  }) : // @ts-ignore
  h(ShimmerLine, {
    "attrs": {
      "height": ShimmerElementsDefaultHeights.line
    }
  });
  return renderedElements;
}

var getElementStyles = memoizeFunction(function (verticalAlign, elementType, elementHeight, backgroundColor, rowHeight) {
  var dif = rowHeight && elementHeight ? rowHeight - elementHeight : 0;
  var borderStyle;

  if (!verticalAlign || verticalAlign === 'center') {
    borderStyle = {
      borderBottomWidth: "".concat(dif ? Math.floor(dif / 2) : 0, "px"),
      borderTopWidth: "".concat(dif ? Math.ceil(dif / 2) : 0, "px")
    };
  } else if (verticalAlign && verticalAlign === 'top') {
    borderStyle = {
      borderBottomWidth: "".concat(dif, "px"),
      borderTopWidth: "0px"
    };
  } else if (verticalAlign && verticalAlign === 'bottom') {
    borderStyle = {
      borderBottomWidth: "0px",
      borderTopWidth: "".concat(dif, "px")
    };
  }

  if (backgroundColor) {
    switch (elementType) {
      case ShimmerElementType.circle:
        return {
          root: _objectSpread(_objectSpread({}, borderStyle), {}, {
            borderColor: backgroundColor
          }),
          svg: {
            fill: backgroundColor
          }
        };

      case ShimmerElementType.gap:
        return {
          root: _objectSpread(_objectSpread({}, borderStyle), {}, {
            borderColor: backgroundColor,
            backgroundColor: backgroundColor
          })
        };

      case ShimmerElementType.line:
        return {
          root: _objectSpread(_objectSpread({}, borderStyle), {}, {
            borderColor: backgroundColor
          }),
          topLeftCorner: {
            fill: backgroundColor
          },
          topRightCorner: {
            fill: backgroundColor
          },
          bottomLeftCorner: {
            fill: backgroundColor
          },
          bottomRightCorner: {
            fill: backgroundColor
          }
        };
    }
  }

  return {
    root: borderStyle
  };
});
/**
 * User should not worry to provide which of the elements is the highest so we do the calculation for him.
 * Plus if user forgot to specify the height we assign their defaults.
 */

function findMaxElementHeight(shimmerElements) {
  var shimmerElementsDefaulted = shimmerElements.map(function (element) {
    switch (element.type) {
      case ShimmerElementType.circle:
        if (!element.height) {
          element.height = ShimmerElementsDefaultHeights.circle;
        }

        break;

      case ShimmerElementType.line:
        if (!element.height) {
          element.height = ShimmerElementsDefaultHeights.line;
        }

        break;

      case ShimmerElementType.gap:
        if (!element.height) {
          element.height = ShimmerElementsDefaultHeights.gap;
        }

        break;
    }

    return element;
  });
  var rowHeight = shimmerElementsDefaulted.reduce(function (acc, next) {
    return next.height ? next.height > acc ? next.height : acc : acc;
  }, 0);
  return rowHeight;
}

export default ShimmerElementsGroupBase$1;
