import { getGlobalClassNames, HighContrastSelector } from '@uifabric/styling';
import _defineProperty from '@babel/runtime/helpers/defineProperty';

var GlobalClassNames = {
  root: 'ms-ShimmerGap-root'
};
function getStyles(props) {
  var height = props.height,
      borderStyle = props.borderStyle,
      theme = props.theme;
  var semanticColors = theme.semanticColors;
  var globalClassNames = getGlobalClassNames(GlobalClassNames, theme);
  var borderStyles = borderStyle || {};
  return {
    root: [globalClassNames.root, theme.fonts.medium, {
      backgroundColor: semanticColors.bodyBackground,
      height: "".concat(height, "px"),
      boxSizing: 'content-box',
      borderTopStyle: 'solid',
      borderBottomStyle: 'solid',
      borderColor: semanticColors.bodyBackground,
      selectors: _defineProperty({}, HighContrastSelector, {
        backgroundColor: 'Window',
        borderColor: 'Window'
      })
    }, borderStyles]
  };
}

export { getStyles };
