import './version.js';
export * from '@uifabric-vue/utilities';
export * from '@uifabric/styling';
export { ActionButton, ActivityItem, Autofill, BaseButton, Breadcrumb, ButtonType, CheckboxVisibility, ChoiceGroup, ColorPickerGridCell, ColorPickerGridCellBase, ColumnActionsMode, ColumnDragEndLocation, ComboBox, CommandBarButton, CompoundButton, ConstrainMode, DefaultButton, DelayedRender, DetailsColumn, DetailsColumnBase, DetailsHeader, DetailsHeaderBase, DetailsList, DetailsListLayoutMode, DetailsRow, DetailsRowBase, DetailsRowCheck, DetailsRowFields, Dialog, DialogBase, DialogContent, DialogContentBase, DialogType, Dropdown, DropdownBase, DropdownMenuItemType, ElementType, Facepile, FacepileBase, IconButton, Image, ImageCoverStyle, ImageFit, ImageLoadState, KeyboardSpinDirection, Link, LinkBase, List, MessageBar, MessageBarButton, MessageBarType, Modal, Nav, OverflowButtonType, OverflowSet, OverflowSetBase, Overlay, Persona, PersonaCoin, PersonaInitialsColor, PersonaPresence, PersonaSize, Popup, PrimaryButton, ProgressIndicator, Rating, RatingSize, ResizeGroup, ResizeGroupBase, ResizeGroupDirection, ResponsiveMode, ScrollToMode, ScrollablePane, ScrollbarVisibility, SearchBox, SelectAllVisibility, Separator, SeparatorBase, Shimmer, ShimmerBase, ShimmerCircle, ShimmerCircleBase, ShimmerElementType, ShimmerElementsDefaultHeights, ShimmerElementsGroup, ShimmerGap, ShimmerGapBase, ShimmerLine, ShimmerLineBase, Slider, SpinButton, Spinner, Stack, StackItem, Sticky, StickyPositionType, SwatchColorPicker, SwatchColorPickerBase, Text, TextField, Toggle, VNodes, VerticalDivider, getMeasurementCache, getNextResizeGroupStateProvider, getPersonaInitialsColor, getStyles, personaPresenceSize, personaSize, presenceBoolean, sizeBoolean, sizeToPixels } from '@uifabric/styling';
export { FontIcon, getIconContent } from './components/Icon/FontIcon.js';
export { Icon } from './components/Icon/index.js';
import Vue from 'vue';
export { LayerBase } from './components/Layer/Layer.base.js';
export { Layer } from './components/Layer/Layer.js';
export { LayerHost } from './components/Layer/LayerHost.js';
export { DirectionalHint } from './common/DirectionalHint.js';
export { Position, RectangleEdge } from './utilities/positioning/positioning.types.js';
export { getBoundsFromTargetWindow, getMaxHeight, getOppositeEdge, positionCallout, positionCard, positionElement } from './utilities/positioning/positioning.js';
export { Callout } from './components/Callout/Callout.js';
export { ContextualMenuItem } from './components/ContextualMenu/ContextualMenuItem.js';
export { ContextualMenuBase } from './components/ContextualMenu/ContextualMenu.base.js';
export { ContextualMenu } from './components/ContextualMenu/ContextualMenu.js';
export { ContextualMenuItemType } from './components/ContextualMenu/ContextualMenu.types.js';
export { getAllSelectedOptions } from './utilities/selectableOption/SelectableOption.js';
export { SelectableOptionMenuItemType } from './utilities/selectableOption/SelectableOption.types.js';
export { LabelBase } from './components/Label/Label.base.js';
export { Label } from './components/Label/Label.js';
export { Checkbox } from './components/Checkbox/index.js';
export { PanelType } from './components/Panel/Panel.types.js';
export { Panel } from './components/Panel/Panel.js';
import VueCompositionAPI from '@vue/composition-api';
import * as index from './components/index.js';
export { index as FabricComponents };
export { loadTheme } from './plugin/loadTheme.js';
import install from './plugin/office-fabric.js';
export { default as Fabric, default } from './plugin/office-fabric.js';
export { Keytip } from './components/Keytip/Keytip.js';
export { initializeIcons } from '@uifabric/icons';
export { registerIcons } from './registerIcons.js';

Vue.use(VueCompositionAPI);
