import { createTheme, loadTheme as loadTheme$1 } from '@uifabric/styling';
import { registerCSSVars } from './registerCSSVars.js';

function loadTheme(theme) {
  var _theme = createTheme(theme);

  var palette = _theme.palette,
      semanticColors = _theme.semanticColors; // generate new css vars

  palette = registerCSSVars('palette', palette);
  semanticColors = registerCSSVars('semanticColors', semanticColors); // update theme

  loadTheme$1({
    palette: palette,
    semanticColors: semanticColors
  });
  return _theme;
}

export { loadTheme };
