import { toKebabCase } from '../utilities/toKebabCase.js';
import * as index from '../components/index.js';
import { loadTheme } from './loadTheme.js';

function install(Vue) {
  var theme = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  for (var componentName in index) {
    var Component = index[componentName];

    if (Component && Component.prototype instanceof Vue) {
      var name = "".concat(options.prefix || 'f', "-").concat(toKebabCase(componentName));
      Vue.component(name, Component);
    }
  }

  loadTheme(theme);
}

export default install;
